/**
 * Copyright 2010 Västra Götalandsregionen
 *
 *   This library is free software; you can redistribute it and/or modify
 *   it under the terms of version 2.1 of the GNU Lesser General Public
 *   License as published by the Free Software Foundation.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the
 *   Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 *   Boston, MA 02111-1307  USA
 */

package se.vgregion.ifeed.formbean;

import java.util.AbstractList;
import java.util.List;

import org.springframework.web.util.UriTemplate;

import se.vgregion.ifeed.types.IFeed;

/**
 * @author Anders Asplund
 *
 */
public class IFeedFormBeanList extends AbstractList<IFeedFormBeanList.IFeedFormBean>{

    private UriTemplate iFeedAtomFeed;
    private List<IFeed> iFeedList;

    public class IFeedFormBean {
        private static final long serialVersionUID = 1L;
        private IFeed iFeed;
        public IFeedFormBean(IFeed iFeed) {
            this.iFeed = iFeed;
        }

        public String getAtomLink() {
            return iFeedAtomFeed.expand(iFeed.getId(), iFeed.getSortField(), iFeed.getSortDirection()).toString();
        }

        public IFeed getiFeed() {
            return iFeed;
        }
    }

    public IFeedFormBeanList(List<IFeed> iFeedList, UriTemplate iFeedAtomFeed) {
        this.iFeedList = iFeedList;
        this.iFeedAtomFeed = iFeedAtomFeed;
    }

    @Override
    public IFeedFormBean get(int index) {
        return new IFeedFormBean(iFeedList.get(index));
    }

    @Override
    public int size() {
        return iFeedList.size();
    }
}
